searchNodes=[{"doc":"A data-driven ecto query builder for nested associations. Quarry allows you to interact with your database thinking only about your data, and generates queries for exactly what you need. You can specify all the filters, loads, and sorts with any level of granularity and at any association level, and Quarry will build a query for you that optimizes for joining just the data that is necessary and no more. To optimize has_many associations, subqueries are used for preloading the entity. This is generally more optimal than joining and selecting all the data because it avoids pulling n*m records into memory.","ref":"Quarry.html","title":"Quarry","type":"module"},{"doc":"Builds a query for an entity type from parameters Examples # Top level attribute iex&gt; Quarry . build ( Quarry.Post , filter : %{ title : &quot;Value&quot; } ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , where : as ( :post ) . title == ^ &quot;Value&quot; &gt; # Field on nested belongs_to relationship iex&gt; Quarry . build ( Quarry.Post , filter : %{ author : %{ publisher : &quot;Publisher&quot; } } ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , join : a1 in assoc ( p0 , :author ) , as : :post_author , where : as ( :post_author ) . publisher == ^ &quot;Publisher&quot; &gt; # Field on nested has_many relationship iex&gt; Quarry . build ( Quarry.Post , filter : %{ comments : %{ body : &quot;comment body&quot; } } ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , join : c1 in assoc ( p0 , :comments ) , as : :post_comments , where : as ( :post_comments ) . body == ^ &quot;comment body&quot; &gt; # Can filter by explicit operation iex&gt; Quarry . build ( Quarry.Post , filter : %{ author : %{ user : %{ login_count : { :eq , 1 } } } } ) iex&gt; Quarry . build ( Quarry.Post , filter : %{ author : %{ user : %{ login_count : { :lt , 1 } } } } ) iex&gt; Quarry . build ( Quarry.Post , filter : %{ author : %{ user : %{ login_count : { :gt , 1 } } } } ) iex&gt; Quarry . build ( Quarry.Post , filter : %{ author : %{ user : %{ login_count : { :lte , 1 } } } } ) iex&gt; Quarry . build ( Quarry.Post , filter : %{ author : %{ user : %{ login_count : { :gte , 1 } } } } ) iex&gt; Quarry . build ( Quarry.Post , filter : %{ title : { :starts_with , &quot;How to&quot; } } ) iex&gt; Quarry . build ( Quarry.Post , filter : %{ title : { :ends_with , &quot;learn vim&quot; } } ) Load examples # Single atom iex&gt; Quarry . build ( Quarry.Post , load : :author ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , join : a1 in assoc ( p0 , :author ) , as : :post_author , preload : [ author : a1 ] &gt; # List of atoms iex&gt; Quarry . build ( Quarry.Post , load : [ :author , :comments ] ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , join : a1 in assoc ( p0 , :author ) , as : :post_author , preload : [ comments : # Ecto.Query &lt; from c0 in Quarry.Comment , as : :post_comment &gt; ] , preload : [ author : a1 ] &gt; # Nested entities iex&gt; Quarry . build ( Quarry.Post , load : [ comments : :user ] ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , preload : [ comments : # Ecto.Query &lt; from c0 in Quarry.Comment , as : :post_comment , join : u1 in assoc ( c0 , :user ) , as : :post_comment_user , preload : [ user : u1 ] &gt; ] &gt; # List of nested entities iex&gt; Quarry . build ( Quarry.Post , load : [ author : [ :user , :posts ] ] ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , join : a1 in assoc ( p0 , :author ) , as : :post_author , join : u2 in assoc ( a1 , :user ) , as : :post_author_user , preload : [ author : [ posts : # Ecto.Query &lt; from p0 in Quarry.Post , as : :post_author_post &gt; ] ] , preload : [ author : { a1 , [ user : u2 ] } ] &gt; # Use Quarry on nested has_many association iex&gt; Quarry . build ( Quarry.Post , load : [ comments : [ filter : %{ body : &quot;comment&quot; } , load : :user ] ] ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , preload : [ comments : # Ecto.Query &lt; from c0 in Quarry.Comment , as : :post_comment , join : u1 in assoc ( c0 , :user ) , as : :post_comment_user , where : as ( :post_comment ) . body == ^ &quot;comment&quot; , preload : [ user : u1 ] &gt; ] &gt; Sort examples # Single field iex&gt; Quarry . build ( Quarry.Post , sort : :title ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , order_by : [ asc : as ( :post ) . title ] &gt; # Multiple fields iex&gt; Quarry . build ( Quarry.Post , sort : [ :title , :body ] ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , order_by : [ asc : as ( :post ) . title ] , order_by : [ asc : as ( :post ) . body ] &gt; # Nested fields iex&gt; Quarry . build ( Quarry.Post , sort : [ [ :author , :publisher ] , :title , [ :author , :user , :name ] ] ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , join : a1 in assoc ( p0 , :author ) , as : :post_author , join : u2 in assoc ( a1 , :user ) , as : :post_author_user , order_by : [ asc : as ( :post_author ) . publisher ] , order_by : [ asc : as ( :post ) . title ] , order_by : [ asc : as ( :post_author_user ) . name ] &gt; # Descending sort iex&gt; Quarry . build ( Quarry.Post , sort : [ :title , desc : :body , desc : [ :author , :publisher ] ] ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , join : a1 in assoc ( p0 , :author ) , as : :post_author , order_by : [ asc : as ( :post ) . title ] , order_by : [ desc : as ( :post ) . body ] , order_by : [ desc : as ( :post_author ) . publisher ] &gt; Limit example iex&gt; Quarry . build ( Quarry.Post , limit : 10 ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , limit : ^ 10 &gt; Offset example iex&gt; Quarry . build ( Quarry.Post , limit : 10 , offset : 20 ) # Ecto.Query &lt; from p0 in Quarry.Post , as : :post , limit : ^ 10 , offset : ^ 20 &gt;","ref":"Quarry.html#build/2","title":"Quarry.build/2","type":"function"},{"doc":"","ref":"Quarry.html#t:filter/0","title":"Quarry.filter/0","type":"type"},{"doc":"","ref":"Quarry.html#t:load/0","title":"Quarry.load/0","type":"type"},{"doc":"","ref":"Quarry.html#t:operation/0","title":"Quarry.operation/0","type":"type"},{"doc":"","ref":"Quarry.html#t:opts/0","title":"Quarry.opts/0","type":"type"},{"doc":"","ref":"Quarry.html#t:sort/0","title":"Quarry.sort/0","type":"type"},{"doc":"A data-driven Ecto Query builder for nested associations. With specifications like GraphQL which seek to granularly fetch data as needed by a client, we are generally forced to either fetch more data than we need to satisfy the greatest need, joining in lots of data to allow filtering on nested data, or we end up limiting the functionality of the endpoint to a few predefined types of selections. Technologies like Dataloader help solve for this by allowing you to fetch nested objects as needed in one query per entity type, but this doesn't help for filtering or sorting by nested entities which require a join to be available in the main query. Also belongs_to associations that only include one sub entity are more efficient to join into the main query, and using Dataloader to fetch this ads an unnecessary query. This is where Quarry comes in, named for its ability to &quot;excavate valuable materials&quot;. You can specify all the filters, loads, and sorts with any level of granularity and at any association level, and Quarry will build a query for you that optimizes for joining just the data you need and no more. To optimize has_many associations, subqueries are used for preloading the entity. This is generally more optimal than joining and selecting all the data because it avoids pulling n*m records into memory. When loading in nested data, you can also apply the full set of Quarry options to filter, sort, limit, and load the list of nested data. This is an internal library and takes all options as atoms. In production, you may want to do some field authorization or pruning prior to passing user data into Quarry. If you are using graphql this is mostly taken care of through defining your schema, but if you are mapping url params in a json api, you'll want to do some pre-checking of authorized fields before converting them to atoms and passing them into Quarry. Quarry allows filtering by any field or association on a schema and you may not want this. It would also be wise to do this checking before converting into atoms since a user could theoretically pass a huge amount of bad keys and fill of the Beam atom store.","ref":"readme.html","title":"Quarry","type":"extras"},{"doc":"The package can be installed by adding quarry to your list of dependencies in mix.exs : def deps do [ { :quarry , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Quarry - Installation","type":"extras"},{"doc":"filter = %{ title : &quot;Hello&quot; , author : %{ name : { :starts_with , &quot;John&quot; } } } load = [ :author , comments : :user ] sort = [ [ :author , :publisher ] , :title ] limit = 10 offset = 20 Quarry . build ( Post , filter : filter , load : load , sort : sort , limit : limit , offset : offset ) See Docs for a more exhaustive list of examples","ref":"readme.html#example","title":"Quarry - Example","type":"extras"},{"doc":"Quarry is quite flexible, and can be used as you see fit, but it basically comes down to 1) Validating input 2) Calling Quarry to build a query, and 3) calling Repo.all() defmodule Blog.Posts do def list ( opts \\\\ %{ } ) do opts = APIUtils . validate_and_cast ( opts ) Post |&gt; Quarry . build ( opts ) |&gt; Repo . all ( ) end end","ref":"readme.html#usage","title":"Quarry - Usage","type":"extras"},{"doc":"HexDocs documentation can be found at https://hexdocs.pm/quarry","ref":"readme.html#documentation","title":"Quarry - Documentation","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Initial implementation of library","ref":"changelog.html#v0-1-0","title":"CHANGELOG - v0.1.0","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Eric Newbury Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]